eink__frame_px:
;eink.c,68 :: 		static void _frame_px( uint8_t x, uint8_t y, uint8_t font_col )
; font_col start address is: 8 (R2)
; y start address is: 4 (R1)
; x start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
STRB	R1, [SP, #4]
UXTB	R1, R0
LDRB	R0, [SP, #4]
; font_col end address is: 8 (R2)
; y end address is: 4 (R1)
; x end address is: 0 (R0)
; x start address is: 4 (R1)
; y start address is: 0 (R0)
; font_col start address is: 8 (R2)
;eink.c,73 :: 		pos = (y * 18) + (x / 4);
MOVS	R3, #18
SXTH	R3, R3
MUL	R4, R0, R3
SXTH	R4, R4
; y end address is: 0 (R0)
LSRS	R3, R1, #2
UXTB	R3, R3
ADDS	R3, R4, R3
; pos start address is: 0 (R0)
UXTH	R0, R3
;eink.c,74 :: 		off = fabs(3 - (x % 4)) * 2;
AND	R3, R1, #3
UXTB	R3, R3
; x end address is: 4 (R1)
RSB	R3, R3, #3
SXTH	R3, R3
VMOV	S0, R3
VCVT.F32	#1, S0, S0
BL	_fabs+0
VMOV.F32	S1, #2
VMUL.F32	S0, S0, S1
VCVT	#1, .F32, S0, S0
VMOV	R4, S0
UXTB	R4, R4
; off start address is: 4 (R1)
UXTB	R1, R4
;eink.c,76 :: 		_frame[ pos ] &= ~( 0x03 << off );
MOVW	R3, #lo_addr(eink__frame+0)
MOVT	R3, #hi_addr(eink__frame+0)
ADDS	R5, R3, R0
MOVS	R3, #3
SXTH	R3, R3
LSLS	R3, R4
SXTH	R3, R3
MVN	R4, R3
SXTH	R4, R4
LDRB	R3, [R5, #0]
ANDS	R3, R4
STRB	R3, [R5, #0]
;eink.c,77 :: 		_frame[ pos ] |= ( ( font_col & 0x03 ) << off );
MOVW	R3, #lo_addr(eink__frame+0)
MOVT	R3, #hi_addr(eink__frame+0)
ADDS	R5, R3, R0
; pos end address is: 0 (R0)
AND	R3, R2, #3
UXTB	R3, R3
; font_col end address is: 8 (R2)
LSL	R4, R3, R1
UXTH	R4, R4
; off end address is: 4 (R1)
LDRB	R3, [R5, #0]
ORRS	R3, R4
STRB	R3, [R5, #0]
;eink.c,78 :: 		}
L_end__frame_px:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of eink__frame_px
eink__char_wr:
;eink.c,80 :: 		static void _char_wr( uint16_t ch_idx )
; ch_idx start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
; ch_idx end address is: 0 (R0)
; ch_idx start address is: 0 (R0)
;eink.c,82 :: 		uint8_t     ch_width = 0;
;eink.c,85 :: 		uint16_t    x = 0;
MOVW	R1, #0
STRH	R1, [SP, #8]
MOVS	R1, #0
STRB	R1, [SP, #12]
;eink.c,86 :: 		uint16_t    y = 0;
;eink.c,88 :: 		uint8_t     temp = 0;
;eink.c,89 :: 		uint8_t     mask = 0;
;eink.c,94 :: 		if( ch_idx < _font_first_char )
MOVW	R1, #lo_addr(eink__font_first_char+0)
MOVT	R1, #hi_addr(eink__font_first_char+0)
LDRH	R1, [R1, #0]
CMP	R0, R1
IT	CS
BCS	L_eink__char_wr0
; ch_idx end address is: 0 (R0)
;eink.c,95 :: 		return;
IT	AL
BAL	L_end__char_wr
L_eink__char_wr0:
;eink.c,97 :: 		if( ch_idx > _font_last_char )
; ch_idx start address is: 0 (R0)
MOVW	R1, #lo_addr(eink__font_last_char+0)
MOVT	R1, #hi_addr(eink__font_last_char+0)
LDRH	R1, [R1, #0]
CMP	R0, R1
IT	LS
BLS	L_eink__char_wr1
; ch_idx end address is: 0 (R0)
;eink.c,98 :: 		return;
IT	AL
BAL	L_end__char_wr
L_eink__char_wr1:
;eink.c,101 :: 		tmp = (ch_idx - _font_first_char) << 2;
; ch_idx start address is: 0 (R0)
MOVW	R1, #lo_addr(eink__font_first_char+0)
MOVT	R1, #hi_addr(eink__font_first_char+0)
LDRH	R1, [R1, #0]
SUB	R1, R0, R1
UXTH	R1, R1
; ch_idx end address is: 0 (R0)
LSLS	R2, R1, #2
UXTH	R2, R2
;eink.c,102 :: 		ch_table = _font + 8 + tmp;
MOVW	R4, #lo_addr(eink__font+0)
MOVT	R4, #hi_addr(eink__font+0)
LDR	R1, [R4, #0]
ADDS	R1, #8
ADDS	R3, R1, R2
;eink.c,103 :: 		ch_width = *ch_table;
LDRB	R6, [R3, #0]
; ch_width start address is: 24 (R6)
;eink.c,105 :: 		offset = (uint32_t)ch_table[1] + ((uint32_t)ch_table[2] << 8) + ((uint32_t)ch_table[3] << 16);
ADDS	R1, R3, #1
LDRB	R1, [R1, #0]
UXTB	R2, R1
ADDS	R1, R3, #2
LDRB	R1, [R1, #0]
LSLS	R1, R1, #8
ADDS	R2, R2, R1
ADDS	R1, R3, #3
LDRB	R1, [R1, #0]
LSLS	R1, R1, #16
ADDS	R2, R2, R1
;eink.c,107 :: 		ch_bitmap = _font + offset;
MOV	R1, R4
LDR	R1, [R1, #0]
ADDS	R1, R1, R2
STR	R1, [SP, #4]
;eink.c,110 :: 		( _font_orientation == FO_VERTICAL_COLUMN ) )
MOVW	R1, #lo_addr(eink__font_orientation+0)
MOVT	R1, #hi_addr(eink__font_orientation+0)
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_eink__char_wr56
MOVW	R1, #lo_addr(eink__font_orientation+0)
MOVT	R1, #hi_addr(eink__font_orientation+0)
LDRB	R1, [R1, #0]
CMP	R1, #2
IT	EQ
BEQ	L_eink__char_wr55
IT	AL
BAL	L_eink__char_wr4
L_eink__char_wr56:
L_eink__char_wr55:
;eink.c,112 :: 		y = y_cord;
MOVW	R1, #lo_addr(eink_y_cord+0)
MOVT	R1, #hi_addr(eink_y_cord+0)
LDRH	R1, [R1, #0]
STRH	R1, [SP, #10]
;eink.c,113 :: 		for (y_cnt = 0; y_cnt < _font_height; y_cnt++)
; y_cnt start address is: 28 (R7)
MOVS	R7, #0
; ch_width end address is: 24 (R6)
; y_cnt end address is: 28 (R7)
UXTB	R2, R6
UXTB	R0, R7
L_eink__char_wr5:
; y_cnt start address is: 0 (R0)
; ch_width start address is: 8 (R2)
MOVW	R1, #lo_addr(eink__font_height+0)
MOVT	R1, #hi_addr(eink__font_height+0)
LDRH	R1, [R1, #0]
CMP	R0, R1
IT	CS
BCS	L_eink__char_wr6
;eink.c,115 :: 		x = x_cord;
MOVW	R1, #lo_addr(eink_x_cord+0)
MOVT	R1, #hi_addr(eink_x_cord+0)
LDRH	R1, [R1, #0]
STRH	R1, [SP, #8]
;eink.c,116 :: 		mask = 0;
; mask start address is: 36 (R9)
MOVW	R9, #0
;eink.c,117 :: 		for( x_cnt = 0; x_cnt < ch_width; x_cnt++ )
; x_cnt start address is: 32 (R8)
MOVW	R8, #0
; y_cnt end address is: 0 (R0)
; ch_width end address is: 8 (R2)
; x_cnt end address is: 32 (R8)
; mask end address is: 36 (R9)
UXTB	R7, R8
UXTB	R8, R0
UXTB	R6, R2
L_eink__char_wr8:
; x_cnt start address is: 28 (R7)
; mask start address is: 36 (R9)
; ch_width start address is: 24 (R6)
; y_cnt start address is: 32 (R8)
CMP	R7, R6
IT	CS
BCS	L_eink__char_wr9
;eink.c,119 :: 		if( !mask )
CMP	R9, #0
IT	NE
BNE	L_eink__char_wr57
; mask end address is: 36 (R9)
;eink.c,121 :: 		temp = *ch_bitmap++;
LDR	R1, [SP, #4]
LDRB	R1, [R1, #0]
STRB	R1, [SP, #12]
LDR	R1, [SP, #4]
ADDS	R1, R1, #1
STR	R1, [SP, #4]
;eink.c,122 :: 		mask = 0x01;
; mask start address is: 36 (R9)
MOVW	R9, #1
; mask end address is: 36 (R9)
;eink.c,123 :: 		}
IT	AL
BAL	L_eink__char_wr11
L_eink__char_wr57:
;eink.c,119 :: 		if( !mask )
;eink.c,123 :: 		}
L_eink__char_wr11:
;eink.c,125 :: 		if( temp & mask )
; mask start address is: 36 (R9)
LDRB	R1, [SP, #12]
AND	R1, R1, R9, LSL #0
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L_eink__char_wr12
;eink.c,127 :: 		_frame_px( x, y, _font_color );
MOVW	R1, #lo_addr(eink__font_color+0)
MOVT	R1, #hi_addr(eink__font_color+0)
LDRH	R1, [R1, #0]
UXTB	R2, R1
LDRH	R1, [SP, #10]
LDRH	R0, [SP, #8]
BL	eink__frame_px+0
;eink.c,128 :: 		}
L_eink__char_wr12:
;eink.c,130 :: 		x++;
LDRH	R1, [SP, #8]
ADDS	R1, R1, #1
STRH	R1, [SP, #8]
;eink.c,131 :: 		mask <<= 1;
LSL	R1, R9, #1
UXTB	R9, R1
;eink.c,117 :: 		for( x_cnt = 0; x_cnt < ch_width; x_cnt++ )
ADDS	R1, R7, #1
; x_cnt end address is: 28 (R7)
; x_cnt start address is: 4 (R1)
;eink.c,132 :: 		}
; mask end address is: 36 (R9)
; x_cnt end address is: 4 (R1)
UXTB	R7, R1
IT	AL
BAL	L_eink__char_wr8
L_eink__char_wr9:
;eink.c,133 :: 		y++;
LDRH	R1, [SP, #10]
ADDS	R1, R1, #1
STRH	R1, [SP, #10]
;eink.c,113 :: 		for (y_cnt = 0; y_cnt < _font_height; y_cnt++)
ADD	R1, R8, #1
; y_cnt end address is: 32 (R8)
; y_cnt start address is: 28 (R7)
UXTB	R7, R1
;eink.c,134 :: 		}
UXTB	R2, R6
; ch_width end address is: 24 (R6)
; y_cnt end address is: 28 (R7)
UXTB	R0, R7
IT	AL
BAL	L_eink__char_wr5
L_eink__char_wr6:
;eink.c,136 :: 		if ( _font_orientation == FO_HORIZONTAL )
MOVW	R1, #lo_addr(eink__font_orientation+0)
MOVT	R1, #hi_addr(eink__font_orientation+0)
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L_eink__char_wr13
;eink.c,137 :: 		x_cord = x + 1;
LDRH	R1, [SP, #8]
ADDS	R2, R1, #1
MOVW	R1, #lo_addr(eink_x_cord+0)
MOVT	R1, #hi_addr(eink_x_cord+0)
STRH	R2, [R1, #0]
IT	AL
BAL	L_eink__char_wr14
L_eink__char_wr13:
;eink.c,139 :: 		y_cord = y;
LDRH	R2, [SP, #10]
MOVW	R1, #lo_addr(eink_y_cord+0)
MOVT	R1, #hi_addr(eink_y_cord+0)
STRH	R2, [R1, #0]
L_eink__char_wr14:
;eink.c,140 :: 		}
IT	AL
BAL	L_eink__char_wr15
L_eink__char_wr4:
;eink.c,143 :: 		y = x_cord;
; ch_width start address is: 24 (R6)
MOVW	R1, #lo_addr(eink_x_cord+0)
MOVT	R1, #hi_addr(eink_x_cord+0)
LDRH	R1, [R1, #0]
STRH	R1, [SP, #10]
;eink.c,145 :: 		for( y_cnt = 0; y_cnt < _font_height; y_cnt++ )
; y_cnt start address is: 28 (R7)
MOVS	R7, #0
; ch_width end address is: 24 (R6)
; y_cnt end address is: 28 (R7)
UXTB	R2, R6
UXTB	R0, R7
L_eink__char_wr16:
; y_cnt start address is: 0 (R0)
; ch_width start address is: 8 (R2)
MOVW	R1, #lo_addr(eink__font_height+0)
MOVT	R1, #hi_addr(eink__font_height+0)
LDRH	R1, [R1, #0]
CMP	R0, R1
IT	CS
BCS	L_eink__char_wr17
;eink.c,147 :: 		x = y_cord;
MOVW	R1, #lo_addr(eink_y_cord+0)
MOVT	R1, #hi_addr(eink_y_cord+0)
LDRH	R1, [R1, #0]
STRH	R1, [SP, #8]
;eink.c,148 :: 		mask = 0;
; mask start address is: 36 (R9)
MOVW	R9, #0
;eink.c,150 :: 		for( x_cnt = 0; x_cnt < ch_width; x_cnt++ )
; x_cnt start address is: 32 (R8)
MOVW	R8, #0
; y_cnt end address is: 0 (R0)
; ch_width end address is: 8 (R2)
; x_cnt end address is: 32 (R8)
; mask end address is: 36 (R9)
UXTB	R7, R8
UXTB	R8, R0
UXTB	R6, R2
L_eink__char_wr19:
; x_cnt start address is: 28 (R7)
; mask start address is: 36 (R9)
; ch_width start address is: 24 (R6)
; y_cnt start address is: 32 (R8)
CMP	R7, R6
IT	CS
BCS	L_eink__char_wr20
;eink.c,152 :: 		if( mask == 0 )
CMP	R9, #0
IT	NE
BNE	L_eink__char_wr58
; mask end address is: 36 (R9)
;eink.c,154 :: 		temp = *ch_bitmap++;
LDR	R1, [SP, #4]
LDRB	R1, [R1, #0]
STRB	R1, [SP, #12]
LDR	R1, [SP, #4]
ADDS	R1, R1, #1
STR	R1, [SP, #4]
;eink.c,155 :: 		mask = 0x01;
; mask start address is: 36 (R9)
MOVW	R9, #1
; mask end address is: 36 (R9)
;eink.c,156 :: 		}
IT	AL
BAL	L_eink__char_wr22
L_eink__char_wr58:
;eink.c,152 :: 		if( mask == 0 )
;eink.c,156 :: 		}
L_eink__char_wr22:
;eink.c,158 :: 		if( temp & mask )
; mask start address is: 36 (R9)
LDRB	R1, [SP, #12]
AND	R1, R1, R9, LSL #0
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L_eink__char_wr23
;eink.c,160 :: 		_frame_px( x, y, _font_color );
MOVW	R1, #lo_addr(eink__font_color+0)
MOVT	R1, #hi_addr(eink__font_color+0)
LDRH	R1, [R1, #0]
UXTB	R2, R1
LDRH	R1, [SP, #10]
LDRH	R0, [SP, #8]
BL	eink__frame_px+0
;eink.c,161 :: 		}
L_eink__char_wr23:
;eink.c,163 :: 		x--;
LDRH	R1, [SP, #8]
SUBS	R1, R1, #1
STRH	R1, [SP, #8]
;eink.c,164 :: 		mask <<= 1;
LSL	R1, R9, #1
UXTB	R9, R1
;eink.c,150 :: 		for( x_cnt = 0; x_cnt < ch_width; x_cnt++ )
ADDS	R1, R7, #1
UXTB	R1, R1
; x_cnt end address is: 28 (R7)
; x_cnt start address is: 4 (R1)
;eink.c,165 :: 		}
; mask end address is: 36 (R9)
; x_cnt end address is: 4 (R1)
UXTB	R7, R1
IT	AL
BAL	L_eink__char_wr19
L_eink__char_wr20:
;eink.c,166 :: 		y++;
LDRH	R1, [SP, #10]
ADDS	R1, R1, #1
STRH	R1, [SP, #10]
;eink.c,145 :: 		for( y_cnt = 0; y_cnt < _font_height; y_cnt++ )
ADD	R7, R8, #1
UXTB	R7, R7
; y_cnt end address is: 32 (R8)
; y_cnt start address is: 28 (R7)
;eink.c,167 :: 		}
UXTB	R2, R6
; ch_width end address is: 24 (R6)
; y_cnt end address is: 28 (R7)
UXTB	R0, R7
IT	AL
BAL	L_eink__char_wr16
L_eink__char_wr17:
;eink.c,168 :: 		y_cord = x - 1;
LDRH	R1, [SP, #8]
SUBS	R2, R1, #1
MOVW	R1, #lo_addr(eink_y_cord+0)
MOVT	R1, #hi_addr(eink_y_cord+0)
STRH	R2, [R1, #0]
;eink.c,169 :: 		}
L_eink__char_wr15:
;eink.c,170 :: 		}
L_end__char_wr:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of eink__char_wr
_eink_init:
;eink.c,176 :: 		void eink_init( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;eink.c,178 :: 		hal_eink_init();
BL	_hal_eink_init+0
;eink.c,179 :: 		EINK_C_DC = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(EINK_C_DC+0)
MOVT	R0, #hi_addr(EINK_C_DC+0)
STR	R1, [R0, #0]
;eink.c,180 :: 		EINK_C_CS = 1;
MOVW	R0, #lo_addr(EINK_C_CS+0)
MOVT	R0, #hi_addr(EINK_C_CS+0)
STR	R1, [R0, #0]
;eink.c,181 :: 		EINK_C_RST = 1;
MOVW	R0, #lo_addr(EINK_C_RST+0)
MOVT	R0, #hi_addr(EINK_C_RST+0)
STR	R1, [R0, #0]
;eink.c,182 :: 		eink_reset();
BL	_eink_reset+0
;eink.c,183 :: 		hal_eink_delay(1000);
MOVW	R0, #1000
BL	_hal_eink_delay+0
;eink.c,184 :: 		eink_write_cmd(EINK_DEEP_SLEEP,           EINK_DATA_SLEEP_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DATA_SLEEP_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_DATA_SLEEP_DEF+0)
MOVS	R0, #16
BL	_eink_write_cmd+0
;eink.c,185 :: 		eink_write_cmd(EINK_DATA_ENTRY,           EINK_DATA_ENTRY_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DATA_ENTRY_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_DATA_ENTRY_DEF+0)
MOVS	R0, #17
BL	_eink_write_cmd+0
;eink.c,186 :: 		eink_write_cmd(EINK_RAM_X_START_END,      EINK_RAM_X_START_END_DEF, 2);
MOVS	R2, #2
MOVW	R1, #lo_addr(eink_EINK_RAM_X_START_END_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_X_START_END_DEF+0)
MOVS	R0, #68
BL	_eink_write_cmd+0
;eink.c,187 :: 		eink_write_cmd(EINK_RAM_Y_START_END,      EINK_RAM_Y_START_END_DEF, 2);
MOVS	R2, #2
MOVW	R1, #lo_addr(eink_EINK_RAM_Y_START_END_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_Y_START_END_DEF+0)
MOVS	R0, #69
BL	_eink_write_cmd+0
;eink.c,188 :: 		eink_write_cmd(EINK_RAM_X_COUNTER,        EINK_RAM_X_COUNTER_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_RAM_X_COUNTER_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_X_COUNTER_DEF+0)
MOVS	R0, #78
BL	_eink_write_cmd+0
;eink.c,189 :: 		eink_write_cmd(EINK_RAM_Y_COUNTER,        EINK_RAM_Y_COUNTER_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_RAM_Y_COUNTER_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_Y_COUNTER_DEF+0)
MOVS	R0, #79
BL	_eink_write_cmd+0
;eink.c,190 :: 		eink_write_cmd(EINK_VCOM_SENSE_DUR,       EINK_SENSE_DURATION_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_SENSE_DURATION_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_SENSE_DURATION_DEF+0)
MOVS	R0, #41
BL	_eink_write_cmd+0
;eink.c,191 :: 		eink_write_cmd(EINK_VCOM_SENSE,           NULL, 0);
MOVS	R2, #0
MOVS	R1, #0
MOVS	R0, #40
BL	_eink_write_cmd+0
;eink.c,192 :: 		eink_write_cmd(EINK_DISPLAY_UPDATE_CTL2,  EINK_DISPLAY_UPDATE_CTL2_1, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL2_1+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL2_1+0)
MOVS	R0, #34
BL	_eink_write_cmd+0
;eink.c,193 :: 		eink_write_cmd(EINK_MASTER_ON,            NULL, 0);
MOVS	R2, #0
MOVS	R1, #0
MOVS	R0, #32
BL	_eink_write_cmd+0
;eink.c,194 :: 		eink_write_cmd(EINK_TEMPERATURE_LOAD,     NULL, 0);
MOVS	R2, #0
MOVS	R1, #0
MOVS	R0, #29
BL	_eink_write_cmd+0
;eink.c,195 :: 		eink_write_cmd(EINK_BOOSTER_SELSECTION,   EINK_BOOSTER_SELSECTION_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_BOOSTER_SELSECTION_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_BOOSTER_SELSECTION_DEF+0)
MOVS	R0, #240
BL	_eink_write_cmd+0
;eink.c,196 :: 		eink_write_cmd(EINK_DISPLAY_UPDATE_CTL1,  EINK_DISPLAY_UPDATE_CTL1_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL1_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL1_DEF+0)
MOVS	R0, #33
BL	_eink_write_cmd+0
;eink.c,197 :: 		eink_write_cmd(EINK_VCOM_WREG,            EINK_VCOM_WREG_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_VCOM_WREG_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_VCOM_WREG_DEF+0)
MOVS	R0, #44
BL	_eink_write_cmd+0
;eink.c,198 :: 		eink_write_cmd(EINK_BORDER_WF,            EINK_BORDER_WF_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_BORDER_WF_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_BORDER_WF_DEF+0)
MOVS	R0, #60
BL	_eink_write_cmd+0
;eink.c,199 :: 		eink_write_cmd(EINK_DISPLAY_UPDATE_CTL2,  EINK_DISPLAY_UPDATE_CTL2_2, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL2_2+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL2_2+0)
MOVS	R0, #34
BL	_eink_write_cmd+0
;eink.c,200 :: 		eink_write_cmd(EINK_WRITE_LUT,            LUT_TME21, sizeof(LUT_TME21));
MOVS	R2, #90
MOVW	R1, #lo_addr(eink_LUT_TME21+0)
MOVT	R1, #hi_addr(eink_LUT_TME21+0)
MOVS	R0, #50
BL	_eink_write_cmd+0
;eink.c,201 :: 		}
L_end_eink_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _eink_init
_eink_reset:
;eink.c,203 :: 		void eink_reset( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;eink.c,205 :: 		hal_eink_delay( 1 );
MOVS	R0, #1
BL	_hal_eink_delay+0
;eink.c,206 :: 		EINK_C_RST = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(EINK_C_RST+0)
MOVT	R0, #hi_addr(EINK_C_RST+0)
STR	R1, [R0, #0]
;eink.c,207 :: 		hal_eink_delay( 2 );
MOVS	R0, #2
BL	_hal_eink_delay+0
;eink.c,208 :: 		EINK_C_RST = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(EINK_C_RST+0)
MOVT	R0, #hi_addr(EINK_C_RST+0)
STR	R1, [R0, #0]
;eink.c,209 :: 		hal_eink_delay( 1000 );
MOVW	R0, #1000
BL	_hal_eink_delay+0
;eink.c,210 :: 		}
L_end_eink_reset:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _eink_reset
_eink_write_cmd:
;eink.c,212 :: 		void eink_write_cmd( uint8_t command, uint8_t *args, uint16_t args_len )
; args start address is: 4 (R1)
SUB	SP, SP, #16
STR	LR, [SP, #0]
STRB	R0, [SP, #8]
STRH	R2, [SP, #12]
; args end address is: 4 (R1)
; args start address is: 4 (R1)
;eink.c,214 :: 		uint8_t *ptr = args;
STR	R1, [SP, #4]
; args end address is: 4 (R1)
;eink.c,216 :: 		while( EINK_C_BSY == 1 );
L_eink_write_cmd24:
MOVW	R4, #lo_addr(EINK_C_BSY+0)
MOVT	R4, #hi_addr(EINK_C_BSY+0)
LDR	R3, [R4, #0]
CMP	R3, #0
IT	EQ
BEQ	L_eink_write_cmd25
IT	AL
BAL	L_eink_write_cmd24
L_eink_write_cmd25:
;eink.c,217 :: 		EINK_C_CS = 0;
MOVS	R4, #0
SXTB	R4, R4
MOVW	R3, #lo_addr(EINK_C_CS+0)
MOVT	R3, #hi_addr(EINK_C_CS+0)
STR	R4, [R3, #0]
;eink.c,218 :: 		EINK_C_DC = 0;
MOVW	R3, #lo_addr(EINK_C_DC+0)
MOVT	R3, #hi_addr(EINK_C_DC+0)
STR	R4, [R3, #0]
;eink.c,219 :: 		hal_eink_write( &command, 1  );
ADD	R3, SP, #8
MOVS	R1, #1
MOV	R0, R3
BL	_hal_eink_write+0
;eink.c,220 :: 		EINK_C_DC = 1;
MOVS	R4, #1
SXTB	R4, R4
MOVW	R3, #lo_addr(EINK_C_DC+0)
MOVT	R3, #hi_addr(EINK_C_DC+0)
STR	R4, [R3, #0]
;eink.c,221 :: 		if( args_len )
LDRH	R3, [SP, #12]
CMP	R3, #0
IT	EQ
BEQ	L_eink_write_cmd26
;eink.c,222 :: 		hal_eink_write( ptr, args_len );
LDRH	R1, [SP, #12]
LDR	R0, [SP, #4]
BL	_hal_eink_write+0
L_eink_write_cmd26:
;eink.c,223 :: 		EINK_C_CS = 1;
MOVS	R4, #1
SXTB	R4, R4
MOVW	R3, #lo_addr(EINK_C_CS+0)
MOVT	R3, #hi_addr(EINK_C_CS+0)
STR	R4, [R3, #0]
;eink.c,224 :: 		while( EINK_C_BSY == 1 );
L_eink_write_cmd27:
MOVW	R4, #lo_addr(EINK_C_BSY+0)
MOVT	R4, #hi_addr(EINK_C_BSY+0)
LDR	R3, [R4, #0]
CMP	R3, #0
IT	EQ
BEQ	L_eink_write_cmd28
IT	AL
BAL	L_eink_write_cmd27
L_eink_write_cmd28:
;eink.c,225 :: 		}
L_end_eink_write_cmd:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _eink_write_cmd
_eink_set_font:
;eink.c,227 :: 		void eink_set_font( const uint8_t *font, uint16_t color, uint8_t orientation )
; orientation start address is: 8 (R2)
; color start address is: 4 (R1)
; font start address is: 0 (R0)
; orientation end address is: 8 (R2)
; color end address is: 4 (R1)
; font end address is: 0 (R0)
; font start address is: 0 (R0)
; color start address is: 4 (R1)
; orientation start address is: 8 (R2)
;eink.c,229 :: 		_font               = font;
MOVW	R3, #lo_addr(eink__font+0)
MOVT	R3, #hi_addr(eink__font+0)
STR	R0, [R3, #0]
;eink.c,230 :: 		_font_first_char    = font[2] + (font[3] << 8);
ADDS	R3, R0, #2
LDRB	R4, [R3, #0]
ADDS	R3, R0, #3
LDRB	R3, [R3, #0]
LSLS	R3, R3, #8
UXTH	R3, R3
ADDS	R4, R4, R3
MOVW	R3, #lo_addr(eink__font_first_char+0)
MOVT	R3, #hi_addr(eink__font_first_char+0)
STRH	R4, [R3, #0]
;eink.c,231 :: 		_font_last_char     = font[4] + (font[5] << 8);
ADDS	R3, R0, #4
LDRB	R4, [R3, #0]
ADDS	R3, R0, #5
LDRB	R3, [R3, #0]
LSLS	R3, R3, #8
UXTH	R3, R3
ADDS	R4, R4, R3
MOVW	R3, #lo_addr(eink__font_last_char+0)
MOVT	R3, #hi_addr(eink__font_last_char+0)
STRH	R4, [R3, #0]
;eink.c,232 :: 		_font_height        = font[6];
ADDS	R3, R0, #6
; font end address is: 0 (R0)
LDRB	R4, [R3, #0]
MOVW	R3, #lo_addr(eink__font_height+0)
MOVT	R3, #hi_addr(eink__font_height+0)
STRH	R4, [R3, #0]
;eink.c,233 :: 		_font_color         = color;
MOVW	R3, #lo_addr(eink__font_color+0)
MOVT	R3, #hi_addr(eink__font_color+0)
STRH	R1, [R3, #0]
; color end address is: 4 (R1)
;eink.c,234 :: 		_font_orientation   = orientation ;
MOVW	R3, #lo_addr(eink__font_orientation+0)
MOVT	R3, #hi_addr(eink__font_orientation+0)
STRB	R2, [R3, #0]
; orientation end address is: 8 (R2)
;eink.c,235 :: 		}
L_end_eink_set_font:
BX	LR
; end of _eink_set_font
_eink_fill_screen:
;eink.c,237 :: 		void eink_fill_screen( uint8_t color )
SUB	SP, SP, #12
STR	LR, [SP, #0]
STRB	R0, [SP, #8]
;eink.c,239 :: 		uint8_t     command = EINK_WRITE_RAM;
MOVS	R1, #36
STRB	R1, [SP, #4]
MOVW	R1, #3096
STRH	R1, [SP, #6]
;eink.c,240 :: 		uint16_t    repeats = _EINK_RAW_IMG_SIZE;
;eink.c,242 :: 		eink_write_cmd( EINK_RAM_X_START_END, EINK_RAM_X_START_END_DEF, 2 );
MOVS	R2, #2
MOVW	R1, #lo_addr(eink_EINK_RAM_X_START_END_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_X_START_END_DEF+0)
MOVS	R0, #68
BL	_eink_write_cmd+0
;eink.c,243 :: 		eink_write_cmd( EINK_RAM_Y_START_END, EINK_RAM_Y_START_END_DEF, 2 );
MOVS	R2, #2
MOVW	R1, #lo_addr(eink_EINK_RAM_Y_START_END_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_Y_START_END_DEF+0)
MOVS	R0, #69
BL	_eink_write_cmd+0
;eink.c,244 :: 		eink_write_cmd( EINK_RAM_X_COUNTER, EINK_RAM_X_COUNTER_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_RAM_X_COUNTER_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_X_COUNTER_DEF+0)
MOVS	R0, #78
BL	_eink_write_cmd+0
;eink.c,245 :: 		eink_write_cmd( EINK_RAM_Y_COUNTER, EINK_RAM_Y_COUNTER_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_RAM_Y_COUNTER_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_Y_COUNTER_DEF+0)
MOVS	R0, #79
BL	_eink_write_cmd+0
;eink.c,246 :: 		eink_write_cmd( EINK_BOOSTER_SELSECTION, EINK_BOOSTER_SELSECTION_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_BOOSTER_SELSECTION_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_BOOSTER_SELSECTION_DEF+0)
MOVS	R0, #240
BL	_eink_write_cmd+0
;eink.c,247 :: 		eink_write_cmd( EINK_DISPLAY_UPDATE_CTL1, EINK_DISPLAY_UPDATE_CTL1_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL1_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL1_DEF+0)
MOVS	R0, #33
BL	_eink_write_cmd+0
;eink.c,248 :: 		eink_write_cmd( EINK_VCOM_WREG, EINK_VCOM_WREG_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_VCOM_WREG_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_VCOM_WREG_DEF+0)
MOVS	R0, #44
BL	_eink_write_cmd+0
;eink.c,249 :: 		eink_write_cmd( EINK_BORDER_WF, EINK_BORDER_WF_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_BORDER_WF_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_BORDER_WF_DEF+0)
MOVS	R0, #60
BL	_eink_write_cmd+0
;eink.c,250 :: 		eink_write_cmd( EINK_DISPLAY_UPDATE_CTL2, EINK_DISPLAY_UPDATE_CTL2_2, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL2_2+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL2_2+0)
MOVS	R0, #34
BL	_eink_write_cmd+0
;eink.c,251 :: 		while( EINK_C_BSY == 1 );
L_eink_fill_screen29:
MOVW	R2, #lo_addr(EINK_C_BSY+0)
MOVT	R2, #hi_addr(EINK_C_BSY+0)
LDR	R1, [R2, #0]
CMP	R1, #0
IT	EQ
BEQ	L_eink_fill_screen30
IT	AL
BAL	L_eink_fill_screen29
L_eink_fill_screen30:
;eink.c,252 :: 		EINK_C_CS = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(EINK_C_CS+0)
MOVT	R1, #hi_addr(EINK_C_CS+0)
STR	R2, [R1, #0]
;eink.c,253 :: 		EINK_C_DC = 0;
MOVW	R1, #lo_addr(EINK_C_DC+0)
MOVT	R1, #hi_addr(EINK_C_DC+0)
STR	R2, [R1, #0]
;eink.c,254 :: 		hal_eink_write( &command, 1 );
ADD	R1, SP, #4
MOV	R0, R1
MOVS	R1, #1
BL	_hal_eink_write+0
;eink.c,255 :: 		EINK_C_DC = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(EINK_C_DC+0)
MOVT	R1, #hi_addr(EINK_C_DC+0)
STR	R2, [R1, #0]
;eink.c,256 :: 		while( repeats-- )
L_eink_fill_screen31:
LDRH	R2, [SP, #6]
LDRH	R1, [SP, #6]
SUBS	R1, R1, #1
STRH	R1, [SP, #6]
CMP	R2, #0
IT	EQ
BEQ	L_eink_fill_screen32
;eink.c,257 :: 		hal_eink_write( &color, 1 );
ADD	R1, SP, #8
MOV	R0, R1
MOVS	R1, #1
BL	_hal_eink_write+0
IT	AL
BAL	L_eink_fill_screen31
L_eink_fill_screen32:
;eink.c,258 :: 		EINK_C_CS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(EINK_C_CS+0)
MOVT	R1, #hi_addr(EINK_C_CS+0)
STR	R2, [R1, #0]
;eink.c,259 :: 		eink_write_cmd( EINK_MASTER_ON, NULL, 0);
MOVS	R2, #0
MOVS	R1, #0
MOVS	R0, #32
BL	_eink_write_cmd+0
;eink.c,260 :: 		eink_write_cmd( EINK_DISPLAY_UPDATE_CTL2, EINK_DISPLAY_UPDATE_CTL2_3, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL2_3+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL2_3+0)
MOVS	R0, #34
BL	_eink_write_cmd+0
;eink.c,261 :: 		eink_write_cmd( EINK_MASTER_ON, NULL, 0);
MOVS	R2, #0
MOVS	R1, #0
MOVS	R0, #32
BL	_eink_write_cmd+0
;eink.c,262 :: 		memset( _frame, color, _EINK_RAW_IMG_SIZE );
MOVW	R2, #3096
SXTH	R2, R2
LDRB	R1, [SP, #8]
MOVW	R0, #lo_addr(eink__frame+0)
MOVT	R0, #hi_addr(eink__frame+0)
BL	_memset+0
;eink.c,263 :: 		}
L_end_eink_fill_screen:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _eink_fill_screen
_eink_image_bmp:
;eink.c,265 :: 		void eink_image_bmp( const uint8_t* img )
SUB	SP, SP, #16
STR	LR, [SP, #0]
STR	R0, [SP, #12]
;eink.c,274 :: 		fr_cnt = 0;
MOVS	R1, #0
STRH	R1, [SP, #10]
;eink.c,275 :: 		cmd     = EINK_WRITE_RAM;
MOVS	R1, #36
STRB	R1, [SP, #8]
;eink.c,276 :: 		eink_write_cmd(EINK_RAM_X_START_END, EINK_RAM_X_START_END_DEF, 2);
MOVS	R2, #2
MOVW	R1, #lo_addr(eink_EINK_RAM_X_START_END_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_X_START_END_DEF+0)
MOVS	R0, #68
BL	_eink_write_cmd+0
;eink.c,277 :: 		eink_write_cmd(EINK_RAM_Y_START_END, EINK_RAM_Y_START_END_DEF, 2);
MOVS	R2, #2
MOVW	R1, #lo_addr(eink_EINK_RAM_Y_START_END_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_Y_START_END_DEF+0)
MOVS	R0, #69
BL	_eink_write_cmd+0
;eink.c,278 :: 		eink_write_cmd(EINK_RAM_X_COUNTER, EINK_RAM_X_COUNTER_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_RAM_X_COUNTER_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_X_COUNTER_DEF+0)
MOVS	R0, #78
BL	_eink_write_cmd+0
;eink.c,279 :: 		eink_write_cmd(EINK_RAM_Y_COUNTER, EINK_RAM_Y_COUNTER_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_RAM_Y_COUNTER_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_Y_COUNTER_DEF+0)
MOVS	R0, #79
BL	_eink_write_cmd+0
;eink.c,280 :: 		eink_write_cmd(EINK_BOOSTER_SELSECTION, EINK_BOOSTER_SELSECTION_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_BOOSTER_SELSECTION_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_BOOSTER_SELSECTION_DEF+0)
MOVS	R0, #240
BL	_eink_write_cmd+0
;eink.c,281 :: 		eink_write_cmd(EINK_DISPLAY_UPDATE_CTL1, EINK_DISPLAY_UPDATE_CTL1_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL1_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL1_DEF+0)
MOVS	R0, #33
BL	_eink_write_cmd+0
;eink.c,282 :: 		eink_write_cmd(EINK_VCOM_WREG, EINK_VCOM_WREG_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_VCOM_WREG_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_VCOM_WREG_DEF+0)
MOVS	R0, #44
BL	_eink_write_cmd+0
;eink.c,283 :: 		eink_write_cmd(EINK_BORDER_WF, EINK_BORDER_WF_DEF, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_BORDER_WF_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_BORDER_WF_DEF+0)
MOVS	R0, #60
BL	_eink_write_cmd+0
;eink.c,284 :: 		eink_write_cmd(EINK_DISPLAY_UPDATE_CTL2, EINK_DISPLAY_UPDATE_CTL2_2, 1);
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL2_2+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL2_2+0)
MOVS	R0, #34
BL	_eink_write_cmd+0
;eink.c,285 :: 		EINK_C_CS = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(EINK_C_CS+0)
MOVT	R1, #hi_addr(EINK_C_CS+0)
STR	R2, [R1, #0]
;eink.c,286 :: 		EINK_C_DC = 0;
MOVW	R1, #lo_addr(EINK_C_DC+0)
MOVT	R1, #hi_addr(EINK_C_DC+0)
STR	R2, [R1, #0]
;eink.c,287 :: 		hal_eink_write( &cmd, 1 );
ADD	R1, SP, #8
MOV	R0, R1
MOVS	R1, #1
BL	_hal_eink_write+0
;eink.c,288 :: 		EINK_C_DC = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(EINK_C_DC+0)
MOVT	R1, #hi_addr(EINK_C_DC+0)
STR	R2, [R1, #0]
;eink.c,289 :: 		for( cnt = 0; cnt < _EINK_BMP_IMG_SIZE; cnt +=2 )
; cnt start address is: 20 (R5)
MOVS	R5, #0
; cnt end address is: 20 (R5)
UXTH	R0, R5
L_eink_image_bmp33:
; cnt start address is: 0 (R0)
MOVW	R1, #24768
CMP	R0, R1
IT	CS
BCS	L_eink_image_bmp34
;eink.c,293 :: 		pixel |= img[ cnt + 1 ];
ADDS	R2, R0, #1
UXTH	R2, R2
LDR	R1, [SP, #12]
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
;eink.c,294 :: 		pixel <<= 8;
LSLS	R2, R1, #8
UXTH	R2, R2
;eink.c,295 :: 		pixel |= img[ cnt ];
LDR	R1, [SP, #12]
ADDS	R1, R1, R0
LDRB	R1, [R1, #0]
ORR	R4, R2, R1, LSL #0
UXTH	R4, R4
;eink.c,297 :: 		tmp += ( pixel & 0xF800 ) >> 11;
AND	R1, R4, #63488
UXTH	R1, R1
LSRS	R3, R1, #11
;eink.c,298 :: 		tmp += ( pixel & 0x07E0 ) >> 5;
AND	R1, R4, #2016
UXTH	R1, R1
LSRS	R2, R1, #5
UXTH	R2, R2
UXTB	R1, R3
ADDS	R1, R1, R2
;eink.c,299 :: 		tmp += ( pixel & 0x001F );
AND	R2, R4, #31
UXTH	R2, R2
UXTB	R1, R1
ADDS	R1, R1, R2
; tmp start address is: 8 (R2)
UXTB	R2, R1
;eink.c,301 :: 		if( tmp < 32 )
UXTB	R1, R1
CMP	R1, #32
IT	CS
BCS	L_eink_image_bmp36
; tmp end address is: 8 (R2)
;eink.c,303 :: 		tmp_pix |= 0x00;
;eink.c,305 :: 		}
IT	AL
BAL	L_eink_image_bmp37
L_eink_image_bmp36:
;eink.c,306 :: 		else if( tmp < 64 )
; tmp start address is: 8 (R2)
CMP	R2, #64
IT	CS
BCS	L_eink_image_bmp38
; tmp end address is: 8 (R2)
;eink.c,308 :: 		tmp_pix |= 0x01;
LDRB	R1, [SP, #9]
ORR	R1, R1, #1
STRB	R1, [SP, #9]
;eink.c,310 :: 		}
IT	AL
BAL	L_eink_image_bmp39
L_eink_image_bmp38:
;eink.c,311 :: 		else if( tmp < 96 )
; tmp start address is: 8 (R2)
CMP	R2, #96
IT	CS
BCS	L_eink_image_bmp40
; tmp end address is: 8 (R2)
;eink.c,313 :: 		tmp_pix |= 0x02;
LDRB	R1, [SP, #9]
ORR	R1, R1, #2
STRB	R1, [SP, #9]
;eink.c,314 :: 		}
IT	AL
BAL	L_eink_image_bmp41
L_eink_image_bmp40:
;eink.c,317 :: 		tmp_pix |= 0x03;
LDRB	R1, [SP, #9]
ORR	R1, R1, #3
STRB	R1, [SP, #9]
;eink.c,318 :: 		}
L_eink_image_bmp41:
L_eink_image_bmp39:
L_eink_image_bmp37:
;eink.c,320 :: 		if(((cnt % 8) == 0) && (cnt != 0))
AND	R1, R0, #7
UXTH	R1, R1
CMP	R1, #0
IT	NE
BNE	L__eink_image_bmp61
CMP	R0, #0
IT	EQ
BEQ	L__eink_image_bmp60
L__eink_image_bmp59:
;eink.c,322 :: 		hal_eink_write( &tmp_pix, 1 );
ADD	R1, SP, #9
STRH	R0, [SP, #4]
MOV	R0, R1
MOVS	R1, #1
BL	_hal_eink_write+0
LDRH	R0, [SP, #4]
;eink.c,323 :: 		_frame[ fr_cnt++ ] = tmp_pix;
LDRH	R2, [SP, #10]
MOVW	R1, #lo_addr(eink__frame+0)
MOVT	R1, #hi_addr(eink__frame+0)
ADDS	R2, R1, R2
LDRB	R1, [SP, #9]
STRB	R1, [R2, #0]
LDRH	R1, [SP, #10]
ADDS	R1, R1, #1
STRH	R1, [SP, #10]
;eink.c,324 :: 		tmp_pix = 0;
MOVS	R1, #0
STRB	R1, [SP, #9]
;eink.c,325 :: 		}
IT	AL
BAL	L_eink_image_bmp45
;eink.c,320 :: 		if(((cnt % 8) == 0) && (cnt != 0))
L__eink_image_bmp61:
L__eink_image_bmp60:
;eink.c,328 :: 		tmp_pix <<= 2;
LDRB	R1, [SP, #9]
LSLS	R1, R1, #2
STRB	R1, [SP, #9]
;eink.c,329 :: 		}
L_eink_image_bmp45:
;eink.c,289 :: 		for( cnt = 0; cnt < _EINK_BMP_IMG_SIZE; cnt +=2 )
ADDS	R1, R0, #2
; cnt end address is: 0 (R0)
; cnt start address is: 20 (R5)
UXTH	R5, R1
;eink.c,330 :: 		}
UXTH	R0, R5
; cnt end address is: 20 (R5)
IT	AL
BAL	L_eink_image_bmp33
L_eink_image_bmp34:
;eink.c,331 :: 		EINK_C_CS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(EINK_C_CS+0)
MOVT	R1, #hi_addr(EINK_C_CS+0)
STR	R2, [R1, #0]
;eink.c,332 :: 		eink_write_cmd( EINK_MASTER_ON, NULL, 0);
MOVS	R2, #0
MOVS	R1, #0
MOVS	R0, #32
BL	_eink_write_cmd+0
;eink.c,333 :: 		eink_write_cmd( EINK_DISPLAY_UPDATE_CTL2, EINK_DISPLAY_UPDATE_CTL2_3, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL2_3+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL2_3+0)
MOVS	R0, #34
BL	_eink_write_cmd+0
;eink.c,334 :: 		eink_write_cmd( EINK_MASTER_ON, NULL, 0);
MOVS	R2, #0
MOVS	R1, #0
MOVS	R0, #32
BL	_eink_write_cmd+0
;eink.c,335 :: 		}
L_end_eink_image_bmp:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _eink_image_bmp
_eink_text:
;eink.c,337 :: 		void eink_text( char *text, uint8_t x, uint8_t y )
; y start address is: 8 (R2)
; x start address is: 4 (R1)
; text start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
; y end address is: 8 (R2)
; x end address is: 4 (R1)
; text end address is: 0 (R0)
; text start address is: 0 (R0)
; x start address is: 4 (R1)
; y start address is: 8 (R2)
;eink.c,341 :: 		char *ptr   = text;
; ptr start address is: 40 (R10)
MOV	R10, R0
; text end address is: 0 (R0)
;eink.c,342 :: 		uint8_t *fr = _frame;
MOVW	R3, #lo_addr(eink__frame+0)
MOVT	R3, #hi_addr(eink__frame+0)
STR	R3, [SP, #8]
;eink.c,344 :: 		if((x >= 72) || (y >= 172))
CMP	R1, #72
IT	CS
BCS	L__eink_text64
CMP	R2, #172
IT	CS
BCS	L__eink_text63
IT	AL
BAL	L_eink_text48
; x end address is: 4 (R1)
; y end address is: 8 (R2)
; ptr end address is: 40 (R10)
L__eink_text64:
L__eink_text63:
;eink.c,345 :: 		return;
IT	AL
BAL	L_end_eink_text
L_eink_text48:
;eink.c,347 :: 		x_cord = x;
; ptr start address is: 40 (R10)
; y start address is: 8 (R2)
; x start address is: 4 (R1)
MOVW	R3, #lo_addr(eink_x_cord+0)
MOVT	R3, #hi_addr(eink_x_cord+0)
STRH	R1, [R3, #0]
; x end address is: 4 (R1)
;eink.c,348 :: 		y_cord = y;
MOVW	R3, #lo_addr(eink_y_cord+0)
MOVT	R3, #hi_addr(eink_y_cord+0)
STRH	R2, [R3, #0]
; y end address is: 8 (R2)
; ptr end address is: 40 (R10)
;eink.c,350 :: 		while( *ptr )
L_eink_text49:
; ptr start address is: 40 (R10)
LDRB	R3, [R10, #0]
CMP	R3, #0
IT	EQ
BEQ	L_eink_text50
;eink.c,351 :: 		_char_wr( *ptr++ );
LDRB	R3, [R10, #0]
UXTH	R0, R3
BL	eink__char_wr+0
ADD	R3, R10, #1
; ptr end address is: 40 (R10)
; ptr start address is: 0 (R0)
MOV	R0, R3
MOV	R10, R0
; ptr end address is: 0 (R0)
IT	AL
BAL	L_eink_text49
L_eink_text50:
;eink.c,353 :: 		cmd = EINK_WRITE_RAM;
MOVS	R3, #36
STRB	R3, [SP, #6]
;eink.c,354 :: 		eink_write_cmd( EINK_RAM_X_START_END, EINK_RAM_X_START_END_DEF, 2 );
MOVS	R2, #2
MOVW	R1, #lo_addr(eink_EINK_RAM_X_START_END_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_X_START_END_DEF+0)
MOVS	R0, #68
BL	_eink_write_cmd+0
;eink.c,355 :: 		eink_write_cmd( EINK_RAM_Y_START_END, EINK_RAM_Y_START_END_DEF, 2 );
MOVS	R2, #2
MOVW	R1, #lo_addr(eink_EINK_RAM_Y_START_END_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_Y_START_END_DEF+0)
MOVS	R0, #69
BL	_eink_write_cmd+0
;eink.c,356 :: 		eink_write_cmd( EINK_RAM_X_COUNTER, EINK_RAM_X_COUNTER_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_RAM_X_COUNTER_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_X_COUNTER_DEF+0)
MOVS	R0, #78
BL	_eink_write_cmd+0
;eink.c,357 :: 		eink_write_cmd( EINK_RAM_Y_COUNTER, EINK_RAM_Y_COUNTER_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_RAM_Y_COUNTER_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_RAM_Y_COUNTER_DEF+0)
MOVS	R0, #79
BL	_eink_write_cmd+0
;eink.c,358 :: 		eink_write_cmd( EINK_BOOSTER_SELSECTION, EINK_BOOSTER_SELSECTION_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_BOOSTER_SELSECTION_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_BOOSTER_SELSECTION_DEF+0)
MOVS	R0, #240
BL	_eink_write_cmd+0
;eink.c,359 :: 		eink_write_cmd( EINK_DISPLAY_UPDATE_CTL1, EINK_DISPLAY_UPDATE_CTL1_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL1_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL1_DEF+0)
MOVS	R0, #33
BL	_eink_write_cmd+0
;eink.c,360 :: 		eink_write_cmd( EINK_VCOM_WREG, EINK_VCOM_WREG_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_VCOM_WREG_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_VCOM_WREG_DEF+0)
MOVS	R0, #44
BL	_eink_write_cmd+0
;eink.c,361 :: 		eink_write_cmd( EINK_BORDER_WF, EINK_BORDER_WF_DEF, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_BORDER_WF_DEF+0)
MOVT	R1, #hi_addr(eink_EINK_BORDER_WF_DEF+0)
MOVS	R0, #60
BL	_eink_write_cmd+0
;eink.c,362 :: 		eink_write_cmd( EINK_DISPLAY_UPDATE_CTL2, EINK_DISPLAY_UPDATE_CTL2_2, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL2_2+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL2_2+0)
MOVS	R0, #34
BL	_eink_write_cmd+0
;eink.c,363 :: 		EINK_C_CS = 0;
MOVS	R4, #0
SXTB	R4, R4
MOVW	R3, #lo_addr(EINK_C_CS+0)
MOVT	R3, #hi_addr(EINK_C_CS+0)
STR	R4, [R3, #0]
;eink.c,364 :: 		EINK_C_DC = 0;
MOVW	R3, #lo_addr(EINK_C_DC+0)
MOVT	R3, #hi_addr(EINK_C_DC+0)
STR	R4, [R3, #0]
;eink.c,365 :: 		hal_eink_write( &cmd, 1 );
ADD	R3, SP, #6
MOVS	R1, #1
MOV	R0, R3
BL	_hal_eink_write+0
;eink.c,366 :: 		EINK_C_DC = 1;
MOVS	R4, #1
SXTB	R4, R4
MOVW	R3, #lo_addr(EINK_C_DC+0)
MOVT	R3, #hi_addr(EINK_C_DC+0)
STR	R4, [R3, #0]
;eink.c,367 :: 		for( cnt = 0; cnt < _EINK_RAW_IMG_SIZE; cnt ++ )
MOVS	R3, #0
STRH	R3, [SP, #4]
L_eink_text51:
LDRH	R4, [SP, #4]
MOVW	R3, #3096
CMP	R4, R3
IT	CS
BCS	L_eink_text52
;eink.c,369 :: 		hal_eink_write( fr++, 1 );
MOVS	R1, #1
LDR	R0, [SP, #8]
BL	_hal_eink_write+0
LDR	R3, [SP, #8]
ADDS	R3, R3, #1
STR	R3, [SP, #8]
;eink.c,367 :: 		for( cnt = 0; cnt < _EINK_RAW_IMG_SIZE; cnt ++ )
LDRH	R3, [SP, #4]
ADDS	R3, R3, #1
STRH	R3, [SP, #4]
;eink.c,370 :: 		}
IT	AL
BAL	L_eink_text51
L_eink_text52:
;eink.c,371 :: 		EINK_C_CS = 1;
MOVS	R4, #1
SXTB	R4, R4
MOVW	R3, #lo_addr(EINK_C_CS+0)
MOVT	R3, #hi_addr(EINK_C_CS+0)
STR	R4, [R3, #0]
;eink.c,372 :: 		eink_write_cmd( EINK_MASTER_ON, NULL, 0);
MOVS	R2, #0
MOVS	R1, #0
MOVS	R0, #32
BL	_eink_write_cmd+0
;eink.c,373 :: 		eink_write_cmd( EINK_DISPLAY_UPDATE_CTL2, EINK_DISPLAY_UPDATE_CTL2_3, 1 );
MOVS	R2, #1
MOVW	R1, #lo_addr(eink_EINK_DISPLAY_UPDATE_CTL2_3+0)
MOVT	R1, #hi_addr(eink_EINK_DISPLAY_UPDATE_CTL2_3+0)
MOVS	R0, #34
BL	_eink_write_cmd+0
;eink.c,374 :: 		eink_write_cmd( EINK_MASTER_ON, NULL, 0);
MOVS	R2, #0
MOVS	R1, #0
MOVS	R0, #32
BL	_eink_write_cmd+0
;eink.c,375 :: 		}
L_end_eink_text:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _eink_text
