_hal_eink_delay:
;eink_hal.c,46 :: 		void hal_eink_delay( uint16_t ms )
; ms start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; ms end address is: 0 (R0)
; ms start address is: 0 (R0)
;eink_hal.c,55 :: 		while( ms-- )
L_hal_eink_delay0:
; ms start address is: 0 (R0)
UXTH	R2, R0
SUBS	R1, R0, #1
UXTH	R0, R1
; ms end address is: 0 (R0)
CMP	R2, #0
IT	EQ
BEQ	L_hal_eink_delay1
; ms end address is: 0 (R0)
;eink_hal.c,56 :: 		Delay_1ms();
; ms start address is: 0 (R0)
BL	_Delay_1ms+0
; ms end address is: 0 (R0)
IT	AL
BAL	L_hal_eink_delay0
L_hal_eink_delay1:
;eink_hal.c,58 :: 		}
L_end_hal_eink_delay:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _hal_eink_delay
_hal_eink_init:
;eink_hal.c,60 :: 		void hal_eink_init()
;eink_hal.c,67 :: 		write_spi_p                 = SPI_Wr_Ptr;
MOVW	R0, #lo_addr(_SPI_Wr_Ptr+0)
MOVT	R0, #hi_addr(_SPI_Wr_Ptr+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(eink_hal_write_spi_p+0)
MOVT	R0, #hi_addr(eink_hal_write_spi_p+0)
STR	R1, [R0, #0]
;eink_hal.c,68 :: 		read_spi_p                  = SPI_Rd_Ptr;
MOVW	R0, #lo_addr(_SPI_Rd_Ptr+0)
MOVT	R0, #hi_addr(_SPI_Rd_Ptr+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(eink_hal_read_spi_p+0)
MOVT	R0, #hi_addr(eink_hal_read_spi_p+0)
STR	R1, [R0, #0]
;eink_hal.c,78 :: 		}
L_end_hal_eink_init:
BX	LR
; end of _hal_eink_init
_hal_eink_write:
;eink_hal.c,84 :: 		)
; count start address is: 4 (R1)
; buffer start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
UXTH	R2, R1
; count end address is: 4 (R1)
; buffer end address is: 0 (R0)
; buffer start address is: 0 (R0)
; count start address is: 8 (R2)
;eink_hal.c,86 :: 		uint8_t *ptr = buffer;
; ptr start address is: 4 (R1)
MOV	R1, R0
; buffer end address is: 0 (R0)
; count end address is: 8 (R2)
; ptr end address is: 4 (R1)
UXTH	R0, R2
;eink_hal.c,88 :: 		while( count-- )
L_hal_eink_write2:
; ptr start address is: 4 (R1)
; count start address is: 0 (R0)
; count start address is: 0 (R0)
UXTH	R3, R0
SUBS	R2, R0, #1
UXTH	R0, R2
; count end address is: 0 (R0)
CMP	R3, #0
IT	EQ
BEQ	L_hal_eink_write3
; count end address is: 0 (R0)
;eink_hal.c,90 :: 		write_spi_p( *ptr++ );
; count start address is: 0 (R0)
LDRB	R2, [R1, #0]
UXTB	R4, R2
STRH	R0, [SP, #4]
STR	R1, [SP, #8]
UXTH	R0, R4
MOVW	R4, #lo_addr(eink_hal_write_spi_p+0)
MOVT	R4, #hi_addr(eink_hal_write_spi_p+0)
LDR	R4, [R4, #0]
BLX	R4
LDR	R1, [SP, #8]
LDRH	R0, [SP, #4]
ADDS	R1, R1, #1
;eink_hal.c,91 :: 		}
; count end address is: 0 (R0)
; ptr end address is: 4 (R1)
IT	AL
BAL	L_hal_eink_write2
L_hal_eink_write3:
;eink_hal.c,92 :: 		}
L_end_hal_eink_write:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _hal_eink_write
_hal_eink_read:
;eink_hal.c,98 :: 		)
; buffer start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
STRH	R1, [SP, #8]
; buffer end address is: 0 (R0)
; buffer start address is: 0 (R0)
;eink_hal.c,100 :: 		uint8_t *ptr = buffer;
STR	R0, [SP, #4]
; buffer end address is: 0 (R0)
;eink_hal.c,102 :: 		while( count-- )
L_hal_eink_read4:
LDRH	R3, [SP, #8]
LDRH	R2, [SP, #8]
SUBS	R2, R2, #1
STRH	R2, [SP, #8]
CMP	R3, #0
IT	EQ
BEQ	L_hal_eink_read5
;eink_hal.c,103 :: 		*ptr++ = read_spi_p( 0xff );
MOVS	R0, #255
MOVW	R4, #lo_addr(eink_hal_read_spi_p+0)
MOVT	R4, #hi_addr(eink_hal_read_spi_p+0)
LDR	R4, [R4, #0]
BLX	R4
LDR	R2, [SP, #4]
STRB	R0, [R2, #0]
LDR	R2, [SP, #4]
ADDS	R2, R2, #1
STR	R2, [SP, #4]
IT	AL
BAL	L_hal_eink_read4
L_hal_eink_read5:
;eink_hal.c,104 :: 		}
L_end_hal_eink_read:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _hal_eink_read
_hal_eink_transfer:
;eink_hal.c,111 :: 		)
; output start address is: 4 (R1)
; input start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
STRH	R2, [SP, #12]
; output end address is: 4 (R1)
; input end address is: 0 (R0)
; input start address is: 0 (R0)
; output start address is: 4 (R1)
;eink_hal.c,113 :: 		uint8_t *in = input;
STR	R0, [SP, #4]
; input end address is: 0 (R0)
;eink_hal.c,114 :: 		uint8_t *out = output;
STR	R1, [SP, #8]
; output end address is: 4 (R1)
;eink_hal.c,116 :: 		while( count-- )
L_hal_eink_transfer6:
LDRH	R4, [SP, #12]
LDRH	R3, [SP, #12]
SUBS	R3, R3, #1
STRH	R3, [SP, #12]
CMP	R4, #0
IT	EQ
BEQ	L_hal_eink_transfer7
;eink_hal.c,117 :: 		*out++ = read_spi_p( *in++ );
LDR	R3, [SP, #4]
LDRB	R3, [R3, #0]
UXTB	R4, R3
UXTH	R0, R4
MOVW	R4, #lo_addr(eink_hal_read_spi_p+0)
MOVT	R4, #hi_addr(eink_hal_read_spi_p+0)
LDR	R4, [R4, #0]
BLX	R4
LDR	R3, [SP, #8]
STRB	R0, [R3, #0]
LDR	R3, [SP, #8]
ADDS	R3, R3, #1
STR	R3, [SP, #8]
LDR	R3, [SP, #4]
ADDS	R3, R3, #1
STR	R3, [SP, #4]
IT	AL
BAL	L_hal_eink_transfer6
L_hal_eink_transfer7:
;eink_hal.c,118 :: 		}
L_end_hal_eink_transfer:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _hal_eink_transfer
